=== debian/changelog ===
libdivide (1.0+dfsg1-2) unstable; urgency=medium

  * d/control: Set Architecture: all.

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 24 Jan 2019 01:50:58 +0300

libdivide (1.0+dfsg1-1) unstable; urgency=low

  * Initial release (Closes: #918932)

 -- Alexander GQ Gerasiov <gq@debian.org>  Thu, 10 Jan 2019 21:23:29 +0300
