=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/,\
repack,compression=xz,repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d*$// \
  https://github.com/ridiculousfish/libdivide/tags .*/v?(\d\S+)\.tar\.gz
