=== debian/changelog ===
libdivide (1.1-1) unstable; urgency=medium

  * New upstream version 1.1
  * d/watch, d/copyright: No need to repack sources anymore.

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 02 Jul 2019 17:46:18 +0300
