=== debian/changelog ===
libdivide (3.0-1) unstable; urgency=medium

  * d/watch: Fix syntax.
  * New upstream version 3.0

 -- Alexander GQ Gerasiov <gq@debian.org>  Fri, 22 Nov 2019 01:40:56 +0300

libdivide (1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change source-only rebuild to allow testing migration.

 -- Boyuan Yang <byang@debian.org>  Fri, 08 Nov 2019 14:07:59 -0500
