=== debian/control ===
Source: libdivide
Priority: optional
Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: debhelper (>= 11), cmake
Standards-Version: 4.3.0
Section: libs
Homepage: https://libdivide.com/
Vcs-Git: https://salsa.debian.org/debian/libdivide.git
Vcs-Browser: https://salsa.debian.org/debian/libdivide.git

Package: libdivide-dev
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: compile-time library for optimizing integer division
 libdivide allows you to replace expensive integer divides with comparatively
 cheap multiplication and bitshifts. Compilers usually do this, but only when
 the divisor is known at compile time. libdivide allows you to take advantage
 of it at runtime. The result is that integer division can become a lot faster.
