=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/ \
  https://github.com/ridiculousfish/libdivide/tags .*/v?(\d\S+)\.tar\.gz
