=== debian/changelog ===
libdivide (5.2.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1072368, #1113139, #1114171)
  * debian/control: Bump debhelper from old 11 to 13.
  * debian/control: Drop dependency on ${shlibs:Depends}, this is
    a devel package.
  * debian/control: Mark binary package as Section: libdevel.
  * Update standards version to 4.7.3, no changes needed.
  * debian/watch: Update to version 5.
  * debian/rules: Add extra build flags -Wno-error=pedantic
    -Wno-error=maybe-uninitialized to avoid build failures.
  * debian/patches/:
    + 0001-CMakeLists.txt-Use-arch-indep-.cmake-install-locatio.patch:
      Add patch to fix .cmake files being installed into arch-dep locations
      for the arch:all binary package.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Use canonical URL in Vcs-Browser.

 -- Boyuan Yang <byang@debian.org>  Wed, 31 Dec 2025 11:06:08 -0500
