=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=pedantic -Wno-error=maybe-uninitialized

%:
	dh $@
