=== debian/watch ===
Version: 5

Source: https://github.com/ridiculousfish/libdivide/tags
Matching-Pattern: .*/v?(\d\S+)\.tar\.gz
Filenamemangle: s/.+\/v?(\d\S+)\.tar\.gz/libdivide-$1\.tar\.gz/
